ManaNotifierDB = {}
ui = {}

local gui

local function sendMessage(msg)
	msg = msg or ""
	if IsInRaid() then
		SendChatMessage(msg, "RAID")
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		SendChatMessage(msg, "INSTANCE_CHAT")
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		SendChatMessage(msg, "PARTY")
	end
end

local function isNumeric(value)
    if value == tostring(tonumber(value)) then
        return true
    else
        return false
    end
end

local function isempty(s)
  return s == nil or s == ''
end

local function replaceStr(text, pattern, replacement)
	text = text:gsub("%" .. pattern, replacement)
	return (text)
end

local sendWarning = false
local sendReady = true
local active = true
local warning = 10
local rewarn = 20
local ready = 60
local repeats = 2

local function setw(value)
	if isNumeric(value) == true then
		if tonumber(value) >= rewarn then
			print("|cffff0000Warning percentage must be lower then Rewarn percentage")
			return (1)
		end
		print("|cff00ff00Setted Warning Percentage to " .. value)
		warning = tonumber(value)
		ManaNotifierDB.warning = tonumber(value)
	else
		print("|cffff0000Warn (%): Argument must be a Number")
		return(1)
	end
	return (0)
end

local function setrew(value)
	if isNumeric(value) == true then
		if tonumber(value) > ready then
			print("|cffff0000Rewarn percentage must be lower or equal to Ready percentage")
			return (1)
		end
		if tonumber(value) <= warning then
			print("|cffff0000Rewarn percentage must be greater then Warning percentage")
			return (1)
		end
		print("|cff00ff00Setted Rewarn Percentage to " .. value)
		rewarn = tonumber(value)
		ManaNotifierDB.rewarn = tonumber(value)
	else
		print("|cffff0000Rewarn (%): Argument must be a Number")
		return(1)
	end
	return (0)
end

local function setr(value)
	if isNumeric(value) == true then
		if tonumber(value) < rewarn then
			print("|cffff0000Ready percentage must be greater or equal to Rewarn percentage")
			return
		end
		print("|cff00ff00Setted Ready Percentage to " .. value)
		ready = tonumber(value)
		ManaNotifierDB.ready = tonumber(value)
	else
		print("|cffff0000Ready (%): Argument must be a Number")
		return(1)
	end
	return (0)
end

local function setrep(value)
	if isNumeric(value) == true then
		if tonumber(value) < 1 or tonumber(value) > 3 then
			print("|cffff0000Repeat Value can only be between 1 and 3")
			return
		end
		print("|cff00ff00Setted Repeat Value to " .. value)
		repeats = tonumber(value)
		ManaNotifierDB.repeats = tonumber(value)
	else
		print("|cffff0000Repetitions: Argument must be a Number")
		return(1)
	end
	return (0)
end

function ui:Save()
	local err = 0

	if setr(eb_r:GetText()) == 1 then
		eb_r:SetText("|cffff0000" .. eb_r:GetText())
		err = 1
	end
	if setrew(eb_rew:GetText()) == 1 then
		eb_rew:SetText("|cffff0000" .. eb_rew:GetText())
		err = 1
	end
	if setw(eb_w:GetText()) == 1 then
		eb_w:SetText("|cffff0000" .. eb_w:GetText())
		err = 1
	end
	if setrep(eb_rep:GetText()) == 1 then
		eb_rep:SetText("|cffff0000" .. eb_rep:GetText())
		err = 1
	end
	
	ManaNotifierDB.warn_msg = eb_warn_msg:GetText()
	ManaNotifierDB.ready_msg = eb_ready_msg:GetText()
	
	if err == 0 then
		gui:Hide()
	end
end

function ui:AD()
	if active == false then
		print("Started |cff2020ffManaNotifier|r")
		active = true
		ManaNotifierDB.active = true
		btn_ad:SetText("Deactivate")
	else
		print("Stoppen |cff2020ffManaNotifier|r")
		active = false
		ManaNotifierDB.active = false
		btn_ad:SetText("Activate")
	end
end

local function mn()
	mana = UnitPower("player" , Enum.PowerType.Mana)
	manaMax = UnitPowerMax("player" , Enum.PowerType.Mana)
	percent = (100 / manaMax) * mana
	if percent >= ready then
		if sendReady == false then
			text = "[ManaNotifier] " .. replaceStr(ManaNotifierDB.ready_msg, "[%%]", floor(percent) .. "%%")
			sendMessage(text)
			sendReady = true
		end
	end
	if percent >= rewarn then
		sendWarning = false
	end
	if percent <= warning then
		if sendWarning == false then
			text = "[ManaNotifier] " .. replaceStr(ManaNotifierDB.warn_msg, "[%%]", floor(percent) .. "%%")
			for i = 1, repeats, 1 do
				sendMessage(text)
			end
			sendWarning = true
			sendReady = false
		end
	end
end

local mnFrame = CreateFrame("FRAME", "ManaNotifier", UIParent);
mnFrame:RegisterEvent("UNIT_POWER");
mnFrame:RegisterEvent("ADDON_LOADED");

function ui:CreateGUI(frame)
	local frame = ui:CreateWindow(frame)
	
	ui:CreateFont(frame, "title", "|cff2020ffManaNotifier", 200, -20, 16)
	
	ui:CreateFont(frame, "setw", "Warn (%)", 30, -50, 12)
	ui:CreateFont(frame, "setrew", "Rewarn (%)", 150, -50, 12)
	ui:CreateFont(frame, "setr", "Ready (%)", 270, -50, 12)
	ui:CreateFont(frame, "setrep", "Repetitions", 390, -50, 12)
	ui:CreateFont(frame, "setwarnmsg", "Warn Message", 30, -110, 12)
	ui:CreateFont(frame, "setreadymsg", "Ready Message", 30, -170, 12)
	ui:CreateFont(frame, "info", "[%] -> Replaced with current Mana in %", 30, -225, 12)
	
	local eb_w = ui:CreateEditBox(frame, "eb_w", 80, 30, 30, -65)
	eb_w:SetText(warning)
	local eb_rew = ui:CreateEditBox(frame, "eb_rew", 80, 30, 150, -65)
	eb_rew:SetText(rewarn)
	local eb_r = ui:CreateEditBox(frame, "eb_r", 80, 30, 270, -65)
	eb_r:SetText(ready)
	local eb_rep = ui:CreateEditBox(frame, "eb_rep", 80, 30, 390, -65)
	eb_rep:SetText(repeats)
	local eb_warn_msg = ui:CreateEditBox(frame, "eb_warn_msg", 440, 30, 30, -125)
	eb_warn_msg:SetText(ManaNotifierDB.warn_msg)
	local eb_ready_msg = ui:CreateEditBox(frame, "eb_ready_msg", 440, 30, 30, -185)
	eb_ready_msg:SetText(ManaNotifierDB.ready_msg)
	
	if active == true then
		local btn_ad = ui:CreateButton(frame, "btn_ad", "Deactivate", 100, 20, 30, -18)
	else
		local btn_ad = ui:CreateButton(frame, "btn_ad", "Activate", 100, 20, 30, -18)
	end
	btn_ad:SetScript("OnClick", function() ui:AD() end)
	
	
	local btn_save = ui:CreateButton(frame, "btn_save", "Save", 150, 35, 50, -250)
	btn_save:SetScript("OnClick", function() ui:Save() end)
	
	local btn_cancel = ui:CreateButton(frame, "btn_cancel", "Cancel", 150, 35, 300, -250)
	btn_cancel:SetScript("OnClick", function() gui:Hide() end)
	
	frame:Hide()
	
	return (frame)
end

function ui:CreateWindow(frame)
	frame:SetWidth(500)
	frame:SetHeight(300)
	frame:SetPoint("CENTER", 0, 0)
	frame:SetBackdrop(
		{
			bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
			edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
			tile = true, tileSize = 32, edgeSize = 32,
			insets = {left = 4, right = 4, top = 4, bottom = 4}
		}
	)
	return (frame)
end

function ui:CreateButton(frame, name, text, width, height, x, y)
	local template = "OptionsButtonTemplate"
	
	local button = CreateFrame("Button", name, frame, template)
		button:SetPoint("TOPLEFT", x, y)
		button:SetWidth(width)
		button:SetHeight(height)
		button:SetText(text)
	return (button)
end

function ui:CreateEditBox(frame, name, width, height, x, y)
	local editbox = CreateFrame("EditBox", name, frame, "InputBoxTemplate")
		editbox:SetPoint("TOPLEFT", x ,y)
		editbox:SetWidth(width)
		editbox:SetHeight(height)
		editbox:SetAutoFocus(false)
		editbox:Show()
	return (editbox)
end

function ui:CreateFont(frame, name, text, x, y, size)
	local fontString = frame:CreateFontString(name)
		fontString:SetPoint("TOPLEFT", x ,y)
		fontString:SetFont("Fonts\\FRIZQT__.TTF", size, "")
		fontString:SetText(text)
	return (fontString)
end

function ui:ShowUI()
	eb_w:SetText(warning)
	eb_rew:SetText(rewarn)
	eb_r:SetText(ready)
	eb_rep:SetText(repeats)
	eb_warn_msg:SetText(ManaNotifierDB.warn_msg)
	eb_ready_msg:SetText(ManaNotifierDB.ready_msg)
	if active == true then
		btn_ad:SetText("Deactivate")
	else
		btn_ad:SetText("Activate")
	end
	gui:Show()
end

local function eventHandler(self, event, addon, what, ...)
	if event == "UNIT_POWER" then
		if what == "MANA" then
			if active == true then
				mn()
			end
		end
	end
	if event == "ADDON_LOADED" and addon == "ManaNotifier" then
		active = ManaNotifierDB.active
		warning = ManaNotifierDB.warning
		rewarn = ManaNotifierDB.rewarn
		ready = ManaNotifierDB.ready
		repeats = ManaNotifierDB.repeats
		if active == nil then
			active = true
		end
		if warning == nil then
			warning = 10
		end
		if rewarn == nil then
			rewarn = 20
		end
		if ready == nil then
			ready = 60
		end
		if repeats == nil then
			repeats = 2
		end
		if ManaNotifierDB.warn_msg == nil then
			ManaNotifierDB.warn_msg = "MANA LOW! ([%])"
		end
		if ManaNotifierDB.ready_msg == nil then
			ManaNotifierDB.ready_msg = "Ready! ([%])"
		end
		
		if active then
			print("|cff2020ffManaNotifier|r activated!\n/mn -> Show UI \n/mn help -> List Commands")
		else
			print("|cff2020ffManaNotifier|r deactivated, activate with  /mn start\n/mn -> Show UI \n/mn help -> List Commands")
		end
		
		gui = ui:CreateGUI(ManaNotifier)
	end
end
mnFrame:SetScript("OnEvent", eventHandler);

local function AddonCommands(msg, editbox)
	local _, _, cmd, args = string.find(msg, "%s?(%w+)%s?(.*)")
	
	if isempty(cmd) then
		ui:ShowUI()
		return
	end
	
	if cmd == "start" then
		print("Started |cff2020ffManaNotifier|r")
		active = true
		ManaNotifierDB.active = true
		return
	elseif cmd == "stop" then
		print("Stoppen |cff2020ffManaNotifier|r")
		active = false
		ManaNotifierDB.active = false
		return
	elseif cmd == "ui" then
		ui:ShowUI()
		return
	elseif cmd == "help" then
		print("|cff2020ffManaNotifier|r\n/mn start -> Start ManaNotifier \n/mn stop -> Stop ManaNotifier \n/mn -> Show UI \n/mn help -> Show this");
		return
	end
	if cmd == "info" then
		if active then
			print("|cff2020ffManaNotifier|r\nActive: activated\nWarning: " .. warning .. "%\nRewarn: " .. rewarn .. "%\nReady: " .. ready .. "%\n" .. "Warning Repetition: " .. repeats)
		else
			print("|cff2020ffManaNotifier|r\nActive: deactivated\nWarning: " .. warning .. "%\nRewarn: " .. rewarn .. "%\nReady: " .. ready .. "%\n" .. "Warning Repetition: " .. repeats)
		end
		return
	end
	
	print("|cff2020ffManaNotifier|r\n/mn start -> Start ManaNotifier \n/mn stop -> Stop ManaNotifier \n/mn -> Show UI \n/mn help -> Show this");
end

SLASH_MN1 = '/mn'

SlashCmdList["MN"] = AddonCommands

